// -------------------------------------------------------------------------------
// 
// 		cwCu		AndroidpJava֌WvO
// 
// 				Ver 3.17e
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

// CN[h ------------------------------------------------------------------
#include "DxJavaAndroid.h"
#include "DxBaseFuncAndroid.h"
#include "DxSystemAndroid.h"
#include "../DxFont.h"
#include "../DxMemory.h"
#include "../DxBaseFunc.h"
#include "../DxSystem.h"
#include "../DxArchive_.h"
#include "../DxLog.h"



#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define LOGI(...) ((void)__android_log_print(ANDROID_LOG_INFO, "AndroidProject1.NativeActivity", __VA_ARGS__))
#define LOGW(...) ((void)__android_log_print(ANDROID_LOG_WARN, "AndroidProject1.NativeActivity", __VA_ARGS__))
#define LOGE(...) ((void)__android_log_print(ANDROID_LOG_ERROR, "threaded_app", __VA_ARGS__))

#ifndef NDEBUG
#  define LOGV(...)  ((void)__android_log_print(ANDROID_LOG_VERBOSE, "threaded_app", __VA_ARGS__))
#else
#  define LOGV(...)  ((void)0)
#endif

// \̒` --------------------------------------------------------------------

DXLIB_JAVA_ANDROID_INFO g_JavaAndroidInfo ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------

// UTF16LE ̏ UTF8 ̃p[^Oo͂
static void JavaAndroid_LogAddUTF8( const char *UTF16LEFormatStr, const char *UTF8Str )
{
	char TempStr[ 1024 ] ;

	ConvString( UTF8Str, DX_CHARCODEFORMAT_UTF8, TempStr, sizeof( TempStr ), DX_CHARCODEFORMAT_UTF16LE ) ;
	DXST_ERRORLOGFMT_ADDUTF16LE(( UTF16LEFormatStr, TempStr )) ;
}

// Java ̃NX̃O[oQƂ擾
extern jclass Java_FindClass_Global( JNIEnv *env, const char *name )
{
	jclass class_local = env->FindClass( name ) ;
	if( class_local == NULL )
	{
		return NULL ;
	}

	jclass class_global = ( jclass )env->NewGlobalRef( class_local ) ;
	env->DeleteLocalRef( class_local ) ;
	class_local = NULL ;

	return class_global ;
}

// Java ̃X^eBbNIuWFNgtB[h̃O[oQƂ擾
extern jobject Java_GetStaticObjectField_Global( JNIEnv *env, jclass clazz, jfieldID fieldID )
{
	jobject fieldobject_local = env->GetStaticObjectField( clazz, fieldID ) ;
	if( fieldobject_local == NULL )
	{
		return NULL ;
	}

	jobject fieldobject_global = env->NewGlobalRef( fieldobject_local ) ;
	env->DeleteLocalRef( fieldobject_local ) ;
	fieldobject_local = NULL ;

	return fieldobject_global ;
}

// Java ̃NX⃁\bh̎QƂ擾
#define FINDCLASS( obj, name )			\
	obj = Java_FindClass_Global( env, name ) ;\
	if( obj == NULL )\
	{\
		JavaAndroid_LogAddUTF8( "\x4a\x00\x61\x00\x76\x00\x61\x00\x20\x00\x43\x00\x6c\x00\x61\x00\x73\x00\x73\x00\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xd6\x53\x97\x5f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Java Class %s ̎擾Ɏs܂" @*/, name ) ;\
		TerminateJavaAndroidInfo( env ) ;\
		return -1 ;\
	}

#define GETMETHOD( obj, class_, name, sig )		\
	obj = env->GetMethodID( class_, name, sig ) ;\
	if( obj == NULL )\
	{\
		JavaAndroid_LogAddUTF8( "\x4a\x00\x61\x00\x76\x00\x61\x00\x20\x00\x4d\x00\x65\x00\x74\x00\x68\x00\x6f\x00\x64\x00\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xd6\x53\x97\x5f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Java Method %s ̎擾Ɏs܂" @*/, name ) ;\
		TerminateJavaAndroidInfo( env ) ;\
		return -1 ;\
	}

#define GETSTATICMETHOD( obj, class_, name, sig )		\
	obj = env->GetStaticMethodID( class_, name, sig ) ;\
	if( obj == NULL )\
	{\
		JavaAndroid_LogAddUTF8( "\x4a\x00\x61\x00\x76\x00\x61\x00\x20\x00\x53\x00\x74\x00\x61\x00\x74\x00\x69\x00\x63\x00\x20\x00\x4d\x00\x65\x00\x74\x00\x68\x00\x6f\x00\x64\x00\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xd6\x53\x97\x5f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Java Static Method %s ̎擾Ɏs܂" @*/, name ) ;\
		TerminateJavaAndroidInfo( env ) ;\
		return -1 ;\
	}

#define GETFIELD( obj, class_, name, sig )		\
	obj = env->GetFieldID( class_, name, sig ) ;\
	if( obj == NULL )\
	{\
		JavaAndroid_LogAddUTF8( "\x4a\x00\x61\x00\x76\x00\x61\x00\x20\x00\x46\x00\x69\x00\x65\x00\x6c\x00\x64\x00\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xd6\x53\x97\x5f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Java Field %s ̎擾Ɏs܂" @*/, name ) ;\
		TerminateJavaAndroidInfo( env ) ;\
		return -1 ;\
	}

#define GETSTATICFIELD( obj, class_, name, sig )		\
	obj = env->GetStaticFieldID( class_, name, sig ) ;\
	if( obj == NULL )\
	{\
		JavaAndroid_LogAddUTF8( "\x4a\x00\x61\x00\x76\x00\x61\x00\x20\x00\x53\x00\x74\x00\x61\x00\x74\x00\x69\x00\x63\x00\x20\x00\x46\x00\x69\x00\x65\x00\x6c\x00\x64\x00\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xd6\x53\x97\x5f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Java Static Field %s ̎擾Ɏs܂" @*/, name ) ;\
		TerminateJavaAndroidInfo( env ) ;\
		return -1 ;\
	}

#define GETSTATICOBJECTFIELD( obj, class_, field_, name )		\
	obj = Java_GetStaticObjectField_Global( env, class_, field_ ) ;\
	if( obj == NULL )\
	{\
		JavaAndroid_LogAddUTF8( "\x4a\x00\x61\x00\x76\x00\x61\x00\x20\x00\x53\x00\x74\x00\x61\x00\x74\x00\x69\x00\x63\x00\x20\x00\x4f\x00\x62\x00\x6a\x00\x65\x00\x63\x00\x74\x00\x20\x00\x46\x00\x69\x00\x65\x00\x6c\x00\x64\x00\x20\x00\x25\x00\x73\x00\x20\x00\x6e\x30\xd6\x53\x97\x5f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"Java Static Object Field %s ̎擾Ɏs܂" @*/, name ) ;\
		TerminateJavaAndroidInfo( env ) ;\
		return -1 ;\
	}
	
extern int SetupJavaAndroidInfo( JNIEnv *env )
{
	if( JAVAANDR.InitializeFlag == TRUE )
	{
		return -1 ;
	}

	if( env == NULL )
	{
		return -1 ;
	}

	FINDCLASS( JAVAANDR.class_Bitmap,              "android/graphics/Bitmap"            ) ;
	FINDCLASS( JAVAANDR.class_BitmapConfig,        "android/graphics/Bitmap$Config"     ) ;
	FINDCLASS( JAVAANDR.class_Canvas,              "android/graphics/Canvas"            ) ;
	FINDCLASS( JAVAANDR.class_Typeface,            "android/graphics/Typeface"          ) ;
	FINDCLASS( JAVAANDR.class_Paint,               "android/graphics/Paint"             ) ;
	FINDCLASS( JAVAANDR.class_PaintFontMetrics,    "android/graphics/Paint$FontMetrics" ) ;

	FINDCLASS( JAVAANDR.class_TextView,            "android/widget/TextView"            ) ;
	FINDCLASS( JAVAANDR.class_TextView_BufferType, "android/widget/TextView$BufferType" ) ;
	FINDCLASS( JAVAANDR.class_EditText,            "android/widget/EditText"            ) ;
	FINDCLASS( JAVAANDR.class_CharSequence,        "java/lang/CharSequence"             ) ;
	FINDCLASS( JAVAANDR.class_Dialog,              "android/app/Dialog"                 ) ;
	FINDCLASS( JAVAANDR.class_AlertDialog,         "android/app/AlertDialog"            ) ;
	FINDCLASS( JAVAANDR.class_AlertDialog_Builder, "android/app/AlertDialog$Builder"    ) ;


	GETSTATICMETHOD( JAVAANDR.method_Bitmap_createBitmap                        , JAVAANDR.class_Bitmap,               "createBitmap",      "(IILandroid/graphics/Bitmap$Config;)Landroid/graphics/Bitmap;" ) ;
	GETMETHOD(       JAVAANDR.method_Bitmap_setPixels                           , JAVAANDR.class_Bitmap,               "setPixels",         "([IIIIIII)V" ) ;
	GETMETHOD(       JAVAANDR.method_Bitmap_getPixels                           , JAVAANDR.class_Bitmap,               "getPixels",         "([IIIIIII)V" ) ;
	GETMETHOD(       JAVAANDR.method_Canvas_newCanvas                           , JAVAANDR.class_Canvas,               "<init>",            "(Landroid/graphics/Bitmap;)V" ) ;
	GETMETHOD(       JAVAANDR.method_Canvas_drawText                            , JAVAANDR.class_Canvas,               "drawText",          "([CIIFFLandroid/graphics/Paint;)V" ) ;
	GETMETHOD(       JAVAANDR.method_Canvas_drawARGB                            , JAVAANDR.class_Canvas,               "drawARGB",          "(IIII)V" ) ;
	GETSTATICMETHOD( JAVAANDR.method_Typeface_create                            , JAVAANDR.class_Typeface,             "create",            "(Ljava/lang/String;I)Landroid/graphics/Typeface;" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_newPaint                             , JAVAANDR.class_Paint,                "<init>",            "()V" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_getFontMetrics                       , JAVAANDR.class_Paint,                "getFontMetrics",    "()Landroid/graphics/Paint$FontMetrics;" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_setTextSize                          , JAVAANDR.class_Paint,                "setTextSize",       "(F)V" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_setTypeface                          , JAVAANDR.class_Paint,                "setTypeface",       "(Landroid/graphics/Typeface;)Landroid/graphics/Typeface;" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_setAntiAlias                         , JAVAANDR.class_Paint,                "setAntiAlias",      "(Z)V" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_setARGB                              , JAVAANDR.class_Paint,                "setARGB",           "(IIII)V" ) ;
	GETMETHOD(       JAVAANDR.method_Paint_measureText                          , JAVAANDR.class_Paint,                "measureText",       "([CII)F" ) ;

	GETMETHOD(       JAVAANDR.method_EditText_newEditText                       , JAVAANDR.class_EditText,             "<init>",            "(Landroid/content/Context;)V" ) ;
	GETMETHOD(       JAVAANDR.method_EditText_setText                           , JAVAANDR.class_EditText,             "setText",           "(Ljava/lang/CharSequence;Landroid/widget/TextView$BufferType;)V" ) ;
	GETMETHOD(       JAVAANDR.method_TextView_getText                           , JAVAANDR.class_TextView,             "getText",           "()Ljava/lang/CharSequence;" ) ;
	GETMETHOD(       JAVAANDR.method_CharSequence_toString                      , JAVAANDR.class_CharSequence,         "toString",          "()Ljava/lang/String;" ) ;
	GETMETHOD(       JAVAANDR.method_Dialog_isShowing                           , JAVAANDR.class_Dialog,               "isShowing",         "()Z" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_newAlertDialog_Builder , JAVAANDR.class_AlertDialog_Builder,  "<init>",            "(Landroid/content/Context;)V" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_setIcon                , JAVAANDR.class_AlertDialog_Builder,  "setIcon",           "(Landroid/graphics/drawable/Drawable;)Landroid/app/AlertDialog$Builder;" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_setTitle               , JAVAANDR.class_AlertDialog_Builder,  "setTitle",          "(Ljava/lang/CharSequence;)Landroid/app/AlertDialog$Builder;" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_setView                , JAVAANDR.class_AlertDialog_Builder,  "setView",           "(Landroid/view/View;)Landroid/app/AlertDialog$Builder;" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_setPositiveButton      , JAVAANDR.class_AlertDialog_Builder,  "setPositiveButton", "(Ljava/lang/CharSequence;Landroid/content/DialogInterface$OnClickListener;)Landroid/app/AlertDialog$Builder;" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_setNegativeButton      , JAVAANDR.class_AlertDialog_Builder,  "setNegativeButton", "(Ljava/lang/CharSequence;Landroid/content/DialogInterface$OnClickListener;)Landroid/app/AlertDialog$Builder;" ) ;
	GETMETHOD(       JAVAANDR.method_AlertDialog_Builder_show                   , JAVAANDR.class_AlertDialog_Builder,  "show",              "()Landroid/app/AlertDialog;" ) ;


	GETSTATICFIELD( JAVAANDR.field_BitmapConfig_ARGB_8888         , JAVAANDR.class_BitmapConfig,            "ARGB_8888",   "Landroid/graphics/Bitmap$Config;" ) ;
	GETFIELD(       JAVAANDR.field_PaintFontMetrics_ascent        , JAVAANDR.class_PaintFontMetrics,        "ascent",      "F" ) ;
	GETFIELD(       JAVAANDR.field_PaintFontMetrics_bottom        , JAVAANDR.class_PaintFontMetrics,        "bottom",      "F" ) ;
	GETFIELD(       JAVAANDR.field_PaintFontMetrics_descent       , JAVAANDR.class_PaintFontMetrics,        "descent",     "F" ) ;
	GETFIELD(       JAVAANDR.field_PaintFontMetrics_leading       , JAVAANDR.class_PaintFontMetrics,        "leading",     "F" ) ;
	GETFIELD(       JAVAANDR.field_PaintFontMetrics_top           , JAVAANDR.class_PaintFontMetrics,        "top",         "F" ) ;
	GETSTATICFIELD( JAVAANDR.field_Typeface_NORMAL                , JAVAANDR.class_Typeface,                "NORMAL",      "I" ) ;
	GETSTATICFIELD( JAVAANDR.field_Typeface_BOLD                  , JAVAANDR.class_Typeface,                "BOLD",        "I" ) ;
	GETSTATICFIELD( JAVAANDR.field_Typeface_ITALIC                , JAVAANDR.class_Typeface,                "ITALIC",      "I" ) ;
	GETSTATICFIELD( JAVAANDR.field_Typeface_BOLD_ITALIC           , JAVAANDR.class_Typeface,                "BOLD_ITALIC", "I" ) ;

	GETSTATICFIELD( JAVAANDR.field_TextView_BufferType_EDITABLE   , JAVAANDR.class_TextView_BufferType,     "EDITABLE",    "Landroid/widget/TextView$BufferType;" ) ;
	GETSTATICFIELD( JAVAANDR.field_TextView_BufferType_NORMAL     , JAVAANDR.class_TextView_BufferType,     "NORMAL",      "Landroid/widget/TextView$BufferType;" ) ;
	GETSTATICFIELD( JAVAANDR.field_TextView_BufferType_SPANNABLE  , JAVAANDR.class_TextView_BufferType,     "SPANNABLE",   "Landroid/widget/TextView$BufferType;" ) ;


	GETSTATICOBJECTFIELD( JAVAANDR.fieldobject_BitmapConfig_ARGB_8888,        JAVAANDR.class_BitmapConfig,        JAVAANDR.field_BitmapConfig_ARGB_8888, "BitmapConfig_ARGB_8888" ) ;
	JAVAANDR.fieldint_Typeface_NORMAL           = env->GetStaticIntField(     JAVAANDR.class_Typeface,            JAVAANDR.field_Typeface_NORMAL      ) ;
	JAVAANDR.fieldint_Typeface_BOLD             = env->GetStaticIntField(     JAVAANDR.class_Typeface,            JAVAANDR.field_Typeface_BOLD        ) ;
	JAVAANDR.fieldint_Typeface_ITALIC           = env->GetStaticIntField(     JAVAANDR.class_Typeface,            JAVAANDR.field_Typeface_ITALIC      ) ;
	JAVAANDR.fieldint_Typeface_BOLD_ITALIC      = env->GetStaticIntField(     JAVAANDR.class_Typeface,            JAVAANDR.field_Typeface_BOLD_ITALIC ) ;

	GETSTATICOBJECTFIELD( JAVAANDR.fieldobject_TextView_BufferType_EDITABLE,  JAVAANDR.class_TextView_BufferType, JAVAANDR.field_TextView_BufferType_EDITABLE,  "TextView_BufferType_EDITABLE"  ) ;
	GETSTATICOBJECTFIELD( JAVAANDR.fieldobject_TextView_BufferType_NORMAL,    JAVAANDR.class_TextView_BufferType, JAVAANDR.field_TextView_BufferType_NORMAL,    "TextView_BufferType_NORMAL"    ) ;
	GETSTATICOBJECTFIELD( JAVAANDR.fieldobject_TextView_BufferType_SPANNABLE, JAVAANDR.class_TextView_BufferType, JAVAANDR.field_TextView_BufferType_SPANNABLE, "TextView_BufferType_SPANNABLE" ) ;


	JAVAANDR.InitializeFlag = TRUE ;

	// I
	return 0 ;
}
#undef FINDCLASS
#undef GETMETHOD
#undef GETSTATICMETHOD
#undef GETFIELD
#undef GETSTATICFIELD

// Java ̃NX⃁\bh̎QƂ̌n
#define JAVA_DELETE_GLOBAL_REF( object )\
	if( object != NULL )\
	{\
		env->DeleteGlobalRef( object ) ;\
		object = NULL ;\
	}
extern int TerminateJavaAndroidInfo( JNIEnv *env )
{
	if( JAVAANDR.InitializeFlag == FALSE )
	{
		return -1 ;
	}

	JAVA_DELETE_GLOBAL_REF( JAVAANDR.class_Bitmap ) ;
	JAVA_DELETE_GLOBAL_REF( JAVAANDR.class_BitmapConfig ) ;
	JAVA_DELETE_GLOBAL_REF( JAVAANDR.class_Canvas ) ;
	JAVA_DELETE_GLOBAL_REF( JAVAANDR.class_Typeface ) ;
	JAVA_DELETE_GLOBAL_REF( JAVAANDR.class_Paint ) ;
	JAVA_DELETE_GLOBAL_REF( JAVAANDR.class_PaintFontMetrics ) ;
	JAVA_DELETE_GLOBAL_REF( JAVAANDR.fieldobject_BitmapConfig_ARGB_8888 ) ;

	JAVAANDR.InitializeFlag = FALSE ;

	return 0 ;
}
#undef JAVA_DELETE_GLOBAL_REF

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE
