// -------------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSp`揈vOwb_t@C
// 
// 				Ver 3.17e
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSWIN_H__
#define __DXGRAPHICSWIN_H__

#include "../DxCompileConfig.h"

#ifndef DX_NON_GRAPHICS

// CN[h ------------------------------------------------------------------
#include "DxGraphicsD3D9.h"
#include "DxGraphicsD3D11.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define GRAWIN		GraphicsManage_Win

#define GRAPHICS_API_NONE						(0)
#define GRAPHICS_API_DIRECT3D9_WIN32			(1)
#define GRAPHICS_API_DIRECT3D11_WIN32			(2)

// \̒` --------------------------------------------------------------------

// Windowsp n[hEGA_OpIWi摜eNX`̍\
struct IMAGEDATA_ORIG_HARD_TEX_PF
{
	union
	{
		int									Dummy ;
#ifndef DX_NON_DIRECT3D11
		IMAGEDATA_ORIG_HARD_TEX_DIRECT3D11	D3D11 ;							// Direct3D11pIWi摜eNX`
#endif // DX_NON_DIRECT3D11
#ifndef DX_NON_DIRECT3D9
		IMAGEDATA_ORIG_HARD_TEX_DIRECT3D9	D3D9 ;							// Direct3D9pIWi摜eNX`
#endif // DX_NON_DIRECT3D9
	} ;
} ;

// Windowsp VhE}bvˑ̍\
struct SHADOWMAPDATA_PF
{
	union
	{
		int									Dummy ;
#ifndef DX_NON_DIRECT3D11
		SHADOWMAPDATA_DIRECT3D11			D3D11 ;								// Direct3D11pVhE}bv
#endif // DX_NON_DIRECT3D11
#ifndef DX_NON_DIRECT3D9
		SHADOWMAPDATA_DIRECT3D9				D3D9 ;								// Direct3D9pVhE}bv
#endif // DX_NON_DIRECT3D9
	} ;
} ;

// Windowsp VF[_[nhˑ̍\
struct SHADERHANDLEDATA_PF
{
	union
	{
		int									Dummy ;
#ifndef DX_NON_DIRECT3D11
		SHADERHANDLEDATA_DIRECT3D11		D3D11 ;								// Direct3D11pVF[_[nh
#endif // DX_NON_DIRECT3D11
#ifndef DX_NON_DIRECT3D9
		SHADERHANDLEDATA_DIRECT3D9		D3D9 ;								// Direct3D9pVF[_[nh
#endif // DX_NON_DIRECT3D9
	} ;
} ;

// Windowsp VF[_[p萔obt@nhˑ̍\
struct SHADERCONSTANTBUFFERHANDLEDATA_PF
{
	union
	{
		int									Dummy ;
#ifndef DX_NON_DIRECT3D11
		SHADERCONSTANTBUFFERHANDLEDATA_DIRECT3D11		D3D11 ;				// Direct3D11pVF[_[p萔obt@nh
#endif // DX_NON_DIRECT3D11
#ifndef DX_NON_DIRECT3D9
		SHADERCONSTANTBUFFERHANDLEDATA_DIRECT3D9		D3D9 ;				// Direct3D9pVF[_[p萔obt@nh
#endif // DX_NON_DIRECT3D9
	} ;
} ;

// Windowsp _obt@nhŎgpˑ̍\
struct VERTEXBUFFERHANDLEDATA_PF
{
	union
	{
		int									Dummy ;
#ifndef DX_NON_DIRECT3D11
		VERTEXBUFFERHANDLEDATA_DIRECT3D11	D3D11 ;							// Direct3D11p_obt@nh
#endif // DX_NON_DIRECT3D11
#ifndef DX_NON_DIRECT3D9
		VERTEXBUFFERHANDLEDATA_DIRECT3D9	D3D9 ;							// Direct3D9p_obt@nh
#endif // DX_NON_DIRECT3D9
	} ;
} ;

// Windowsp CfbNXobt@nhŎgpˑ̍\
struct INDEXBUFFERHANDLEDATA_PF
{
	union
	{
		int									Dummy ;
#ifndef DX_NON_DIRECT3D11
		INDEXBUFFERHANDLEDATA_DIRECT3D11	D3D11 ;							// Direct3D11pCfbNXobt@nh
#endif // DX_NON_DIRECT3D11
#ifndef DX_NON_DIRECT3D9
		INDEXBUFFERHANDLEDATA_DIRECT3D9		D3D9 ;							// Direct3D9pCfbNXobt@nh
#endif // DX_NON_DIRECT3D9
	} ;
} ;

// Windows ɈˑĂݒ
struct GRAPHICS_SETTING_WIN
{
	int									DisableAeroFlag ;					// Aero 𖳌ɂ邩ǂ̃tO( TRUE:ɂ  FALSE:ɂȂ )
	int									UseGraphicsAPI ;					// gpOtBbNXAPI( GRAPHICS_API_DIRECT3D9_WIN32 Ȃ )
	int									NotUseDirect3D11 ;					// `揈 Direct3D11 gpȂǂ( TRUE:gpȂ  FALSE:gp )
	int									UseMultiThread ;					// }`XbhΉtOgǂ

	HWND								ScreenFlipTargetWindow ;			// ScreenFlip ̑ΏۂƂEChE
	double								ScreenFlipTargetWindowScaleX ;		// ScreenFlip ̑ΏۂƂEChEɓ]ۂ̊g嗦X
	double								ScreenFlipTargetWindowScaleY ;		// ScreenFlip ̑ΏۂƂEChEɓ]ۂ̊g嗦Y
} ;

// `揈֌W Windows ɈˑĂ̍\
struct GRAPHICSMANAGE_WIN
{
	int									UseChangeDisplaySettings ;			// ChangeDisplaySettings gpĉʃ[hύXǂ( TRUE:ChangeDisplaySettings gp  FALSE:ChangeDisplaySettings ͎gpĂȂ )

	GRAPHICS_SETTING_WIN				Setting ;							// Windows ɈˑĂݒ

//	RECT								LastCopySrcRect ;					// ŌɃtBbg]Ƃ̃Rs[`
//	RECT								LastCopyDestRect ;					// ŌɃtBbg]Ƃ̃Rs[`

	int									FullScreenBlackFillCounter ;		// tXN[[hŉʑŜœhԂJE^[
} ;

// ϐ錾 --------------------------------------------------------------

extern GRAPHICSMANAGE_WIN GraphicsManage_Win ;

// ֐vg^Cv錾-----------------------------------------------------------

// DirectX ֘A֐
extern	void	Graphics_ReleaseDirectXObject( void ) ;							// DirectX ̃IuWFNg

extern	void	Graphics_Win_MessageLoop_Process( void ) ;						// bZ[W[vɍsׂs
extern	void	Graphics_Win_WM_ACTIVATE_ActiveProcess( void ) ;				// WM_ACTIVATE bZ[W̏ŁAEChE[hɃANeBuɂȂۂɌĂ΂֐

// ݒ֌W֐
extern	int		Graphics_Win_SetDialogBoxMode( int Flag ) ;						// _CAO{bNX[hύX


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_GRAPHICS

#endif // __DXGRAPHICSWIN_H__
